#ifndef  __DrvMercFR_H__
#define  __DrvMercFR_H__

#ifndef  __THE_DLL__

typedef int ( __stdcall *TConnect)(
         unsigned char  PortNum,
         unsigned short BaudRate,
         unsigned short Timeout,
         char           *psw);

typedef int ( __stdcall *TDisconnect)( void );
typedef int ( __stdcall *TGetLastDocNum)( void );

typedef int ( __stdcall *TRegisterOper)(
         int   OperNum,
         char *OperName );

typedef int ( __stdcall *TGetCurrOper)(int *OperNum);

typedef int ( __stdcall *TGetTaxNum)(int *TaxNum);

typedef int ( __stdcall *TGetTaxRate)(
         int TaxIndex,
         int *TaxVal,
         char *Name);

typedef int ( __stdcall *TOpenReceipt) (int OperType);


typedef int ( __stdcall  *TAddRecEntry) (
         double Price,            //  /
         int Quantity,            // 
         int  QuantityPrec,       //  
         double Sum,              //  (   )
         int Depart,              // 
         int TaxIndex,            //  
         int Code,                // 
         char *Name               // 
);

typedef int  ( __stdcall  *TAddRecAdjust) (double Sum, char *Text );

typedef int  ( __stdcall  *TAddPay) (
         int PayType,
         double SumCash,
         double SumCashless
);

typedef int  ( __stdcall *TCloseReceipt)( int flag );

typedef int  ( __stdcall *TZreport)( void );

typedef int  ( __stdcall *TXreport)( void );

typedef int  ( __stdcall *TGetExErrorCode)( void );

typedef int  ( __stdcall *TQueryEcrIdent) (
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion 
);
typedef int  ( __stdcall *TQueryEcrIdentEx) (
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion, 
         char *SN
);


//          DateTime -       
//          (dd.mm.yy hh:mm:ss)
typedef int  ( __stdcall *TQueryEcrDateTime) ( char  *pdatetime);

typedef int  ( __stdcall *TSynchronazeDateTime) (void);

#endif


///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
//---  
#define  SUCCESS                     0

//---     
#define  ERR_CONN_OPENED             1

//---     
#define  ERR_CONN_CLOSED             2

//---   
#define  ERR_NO_RESPONSE             3

//---   
#define  ERR_REC_OPENED              4

//---   
#define  ERR_REC_NOOPEN              5

//---     ;
#define  ERR_DOC_OVERFLOW            7

//---   .
#define  ERR_INVALID_ARG            14

//---   
#define  ERR_OS_ERROR               17

//---  
#define  ERR_ECR_ERROR              18

//---   
#define  ERR_INTERNAL               20

//---   
#define  ERR_BLANKING_NEEDED        21

//---      
#define  ERR_TO_LITTLE_CASHES       22

//---   
#define  ERR_VALUE_NOT_DEFINED      23

//---  
#define  ERR_PASSWORD_NOT_VALID     24


///////////////////////////////////////////////////////////////////////////////
//     ( ERR_INVALID_ARG).
///////////////////////////////////////////////////////////////////////////////
//---   
#define  EX_IAE_NO_ERROR                 0

//---   
#define  EX_IAE_INVALID_PORT_NUM         1

//---     
#define  EX_IAE_INVALID_BAUD_RATE        2

//---        
#define  EX_IAE_UNSUPPORTED_BAUD_RATE    3

//---   
#define  EX_IAE_INVALID_TIMEOUT          4

//---   
#define  EX_IAE_INVALID_OPER_NUM         6

//---   
#define  EX_IAE_INVALID_OPER_TYPE        8

//---      
#define  EX_IAE_UNSUPPORTED_OPER_TYPE    9

//---   
#define  EX_IAE_INVALID_PAY_TYPE        17

//---      
#define  EX_IAE_UNSUPPORTED_PAY_TYPE    18

//---    
#define  EX_IAE_INVALID_PAY_SUM         20

//---    
#define  EX_IAE_INVALID_ENTRY_SUM       21

//---   
#define  EX_IAE_INVALID_DEPARTMENT      22

//---    
#define  EX_IAE_INVALID_ENTRY_CODE      23

//---    / 
#define  EX_IAE_INVALID_ADJUSTMENT      24

//---   
#define  EX_IAE_INVALID_QUANTITY        25

//---    
#define  EX_IAE_INVALID_QUAN_PREC       26

//---     
#define  EX_IAE_INVALID_TAX_INDEX       27

//---    
#define  EX_IAE_TOTAL_OVERFLOW          28

//---    
#define  EX_IAE_INVALID_HEADER_LINE     29

//---   
#define  EX_IAE_INVALID_ENTRY_TYPE      30


///////////////////////////////////////////////////////////////////////////////
//      ( ERR_ECR_ERROR).
///////////////////////////////////////////////////////////////////////////////
//---    
#define  EXT_EE_NO_ERROR                0

//---    
#define  EXT_EE_END_OF_PAPER            1

//---  
#define  EXT_EE_PRN_ERROR               2

#ifdef  __THE_DLL__   //=======================================================

typedef struct {
//-----------------------------------------------------------------------------
//    optype:
//     0-; 1-; 2-; 3-
//     10 - ; 11-; 12-  
//
//   ,    ,  , 
//     -     summa
//     -uidop   : 0-, 1-
//-----------------------------------------------------------------------------

    int            optype;       //  
    int            opnum;        //    
    unsigned char  uidop;        //
    unsigned char  plu[3];       // 
    unsigned char  kolvo[7];     //  (   )
    unsigned char  summa[7];     //  ( )
    unsigned char  tax;          //  
    unsigned char  depth;        //  
    char           tovname[33];  // 
} DocOperationData;

 #define   STX   0x02
 #define   ETX   0x03
 #define   DLE   0x10
 #define   RDY   0xC5
 #define   WAIT  0xC7
 #define   ACK   0xCA
 #define   NAK   0xC6
 #define   BUSY  0xC9
 #define   SYN   0xCC
 #define   REJ   0xC3
 #define   DISC  0xC0
 #define   RST   0xCF


 enum {
   ENET_SUCCS,          //  

   //*** ,   
   ENET_CMDNOT,         // 1    
   ENET_BADMODE,        // 2      
   ENET_FORMAT,         // 3      
   ENET_BADSN,          // 4     -     
   ENET_BADTAX,         // 5     -    
   ENET_DIFFMD,         // 6     -    

   ENET_ONLZERO,        // 7        
   ENET_DOCOPEN,        // 8        !

   ENET_NOTFIND,        // 9  /   (on-line)
   ENET_NOTKOLV,        // 10    (on-line)
   ENET_ONLCEIL,        // 11   !

   ENET_NOTDISCl,       // 12   
   ENET_DISCREJ,        // 13     

   ENET_BADCARD,        // 14      
   ENET_CARDOVR,        // 15      -  

   ENET_BADPSW,         // 16      
   ENET_BADPLU,         // 17   
   ENET_JFATAL,         // 18    
   ENET_NEEDREG,        // 19    

   ENET_PU_ERR,         // 20 :  
   ENET_DOCOVR,         // 21 :   
   ENET_BADOPER,        // 22 :  
   ENET_NOTAX,          // 23 :    
   ENET_JROVER,         // 24 :  
   ENET_NOMONEY,        // 25 :   
   ENET_ERDEPTH,        // 26 :   (   )
   ENET_REJECT,         // 27  , 

   //***    ***
   ENET_BADNOM,         //    (  )
   ENET_TX_ERR,         //  
   ENET_RX_ERR,         //  
   ENET_BADCRC,         //   
   ENET_TIMEOUT,        // -
   ENET_OVERSIZE,       // 
   ENET_NOT_CONN        //   
 };

#endif //======================================================================


/*****************************************************************************/
#endif
/*****************************************************************************/
