unit arMaxX;

interface

uses
  Windows, ComObj, ActiveX, kkmnetsrvdbf_io_TLB, StdVcl, SysUtils,
  Controls, Dialogs, IniObject;

type
  TConnect = function(PortNum: byte; BaudRate: word; Timeout: word; psw: PChar): integer; stdcall;
  TDisconnect = function: integer; stdcall;
  TRegisterOper = function(OperNum: integer; OperName: PChar): integer; stdcall;
  TGetCurrOper = function(OperNum: PInteger): integer; stdcall;
  TGetTaxNum = function(TaxNum: PInteger): integer; stdcall;
  TGetTaxRate = function(TaxIndex: integer; TaxVal: pinteger; Name: PChar): integer; stdcall;
  TOpenReceipt = function(OperType: Integer): integer; stdcall;
  TAddRecEntry = function(Price: double; Quantity: integer; QuantityPrec: integer; Sum: double; Depart: integer; TaxIndex: integer; Code: integer; Name: pchar): integer; stdcall;
  TAddRecAdjust = function(Sum: double; Text: Pchar): integer; stdcall;
  TAddPay = function(PayType: integer; SumCash, SumCashless: double): integer; stdcall;
  TCloseReceipt = function(flag: Integer): integer; stdcall;
  TZreport = function: integer; stdcall;
  TXreport = function: integer; stdcall;
  TGetExErrorCode = function: integer; stdcall;
  TQueryEcrIdent = function(ModelName,  Manufacturer, FirmvareVersion: PChar): integer; stdcall;
  TQueryEcrDateTime = function(pdatetime: PChar): integer; stdcall;
  TSynchronazeDateTime = function: integer; stdcall;

  TKKMNetDBSrvDataGate = class(TAutoObject, IKKMNetDBSrvDataGate)
  protected
  public
    // /
    procedure ConnectByAlias(const AliasName: WideString); safecall;
    procedure ConnectByPath(const Path: WideString); safecall;
    procedure DisconnectFromDB; safecall;

    //   
    procedure ExecuteW(const SQL: WideString); safecall;
    procedure ExecuteWS(const SQL: WideString); safecall;
    procedure SelectR(const SQL, OutFileName: WideString); safecall;
    procedure SelectW(const SQL, OutFileName: WideString); safecall;
    procedure SelectWS(const SQL, OutFileName: WideString); safecall;

    //  
    procedure InsertOrUpdateTovar(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarAll(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarByName(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE_BC(const InFileName: WideString); safecall; //   
    procedure InsertOrUpdateTovarInv(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarOutOfRoad(const InFileName: WideString); safecall;

    //    
    function GetIDStoreLength: SYSINT; safecall;
    function GetIDTovarLength: SYSINT; safecall;
    procedure GetTovarsInfo(const OutFileName: WideString); safecall;
    procedure ChangeBarcodes(const InFileName: WideString); safecall;
    procedure DeleteGroup(IDGROUP: Integer); safecall;
    procedure DeleteTovar(IDTOV: Integer); safecall;
    procedure UpdateTovarUseBefore(const InFileName: WideString); safecall;
    procedure UpdTovCountryGTDByExtrn(const InFileName: WideString); safecall;
    procedure GetRestsForDate(const OutFileName, DRest: WideString); safecall;

    //    ( arMaxLabel)
    procedure AddPackParty(const InFileName: WideString); safecall;
    procedure GetPackParty(const OutFileName, PartyNo: WideString); safecall;

    //    (  )
    function CashInOut(const ARMName: WideString; Value: Currency): WideString; safecall;
    function CloseCheck: WideString; safecall;
    function ContinueAfterError(const ARMName: WideString): WideString; safecall;
    function RepeatLastCheck(const ARMName: WideString): WideString; safecall;
    function XReport(const ARMName: WideString): WideString; safecall;
    function ZReport(const ARMName: WideString): WideString; safecall;
    procedure AddCheckLine(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString); safecall;
    procedure AddCheckLineDep(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; Dep: Integer); safecall;
    procedure CreateCheck(const ARMName: WideString; CheckKind: Integer); safecall;

    //    
    procedure GetKSSales(const OutFileName: WideString); safecall;
    procedure GetKSSales_IsOK(IsOK: Shortint); safecall;

    //  
    procedure GetLastDocs(const OutFileName: WideString); safecall;
    procedure GetLastDocs_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsBySN(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastDocsBySN_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsWSpec(const HeadFileName, SpecFileName: WideString); safecall;
    procedure GetLastDocsWSpec_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsWSpecWOZero(const HeadFileName, SpecFileName: WideString); safecall;
    procedure GetLastDocsWSpecWOZero_IsOK(IsOK: Shortint); safecall;

    //  
    procedure GetChecsFromTo(const OutFileName, DFrom, DTo: WideString); safecall;
    procedure GetChecsZRep(const OutFileName, Z_REP: WideString); safecall;
    procedure GetChecsZRepKKM(const OutFileName, ZR_KKM: WideString); safecall;
    procedure GetChecsZRepSokr(const OutFileName, ZR_Sokr: WideString); safecall;
    procedure GetLastChecs_X(const OutFileName: WideString); safecall;
    procedure GetLastChecs_Z(const OutFileName: WideString); safecall;
    procedure GetLastChecs_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecsByKKMSN_X(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastChecsByKKMSN_Z(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastChecsByKKMSN_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetLastGrChecks_X(const OutFileName: WideString); safecall;
    procedure GetLastGrChecks_Z(const OutFileName: WideString); safecall;
    procedure GetLastGrChecks_Z_IsOK(IsOK: Shortint); safecall;

    //   Z-
    procedure GetLastZReports_X(const OutFileName: WideString); safecall;
    procedure GetLastZReports_Z(const OutFileName: WideString); safecall;
    procedure GetLastZReports_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetZReportsFromTo(const OutFileName, DFrom, DTo: WideString); safecall;

    //   Z-
    procedure GetLastZReportsShort_X(const OutFileName: WideString); safecall;
    procedure GetLastZReportsShort_Z(const OutFileName: WideString); safecall;
    procedure GetLastZReportsShort_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetZReportsShortFromTo(const OutFileName, DFrom, DTo: WideString); safecall;

    //  
    procedure GetCurrOst(const OutFileName: WideString); safecall;
    procedure InsertOrUpdateDicountCards(const InFileName: WideString); safecall;
    procedure GetAgentsInfo(const OutFileName: WideString); safecall;

    // /   .   .
    function GetCurrentRetailSkald: WideString; safecall;
    function SaveFromKKMSrvToDBF: WideString; safecall;
    function SaveFromKKMsrvToDBFAvg: WideString; safecall;
    function TradeGetPrices: WideString; safecall;
    procedure GetLastDocsEx(const OutFileName: WideString); safecall;
    procedure GetLastDocsEx_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecks(const OutFileName: WideString); safecall;
    procedure GetLastChecks_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecsOfRoad(const OutFileName: WideString); safecall;
    procedure GetLastChecsOfRoad_IsOK(IsOK: Shortint); safecall;
    procedure GetPrihodToBar_IsOK(IsOK: Shortint); safecall;
    procedure GetPrihodToBar(const OutFileName: WideString); safecall;
    procedure InsertOrUpdateAgents(const InFileName: WideString); safecall;
    procedure InsertOrUpdateStudents(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE_Fast(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarFromBar(const InFileName: WideString); safecall;
    procedure InsSalesFromBar(const InFileName: WideString); safecall;
    procedure LoadFromDBFToKKMSrv(const InFileName: WideString); safecall;
    procedure TestDBFSpeed(const OutFileName: WideString); safecall;
    procedure TradeLoadTovarFromBar(var InFileName: WideString); safecall;
    procedure X10UnitSetState(const Name: WideString; PowerOn,
      PowerValue: Integer); safecall;
    function Get_X10UnitsCount: Integer; safecall;
    function X10UnitName(Index: Integer): WideString; safecall;
    function X10UnitOnOffState(Index: Integer): Integer; safecall;
    function X10UnitValue(Index: Integer): Integer; safecall;
    procedure StartGetTovarInfo; safecall;
    function Get_MemRowCount: Integer; safecall;
    function MemData(Row, Field: Integer): WideString; safecall;
    function MemDataN(Row, Field: Integer): WideString; safecall;
    function Get_MemFieldCount: Integer; safecall;
    function MemFieldName(Field: Integer): WideString; safecall;
    function MemID2Row(ID: Integer): Integer; safecall;
    function Get_DataBasePath: WideString; safecall;
    procedure Set_DataBasePath(const Value: WideString); safecall;
    { Protected declarations }
  private
    _Connect: TConnect;
    _Disconnect: TDisconnect;
    _RegisterOper: TRegisterOper;
    _GetCurrOper: TGetCurrOper;
    _GetTaxNum: TGetTaxNum;
    _GetTaxRate: TGetTaxRate;
    _OpenReceipt: TOpenReceipt;
    _AddRecEntry: TAddRecEntry;
    _AddRecAdjust: TAddRecAdjust;
    _AddPay: TAddPay;
    _CloseReceipt: TCloseReceipt;
    _Zreport: TZreport;
    _Xreport: TXreport;
    _GetExErrorCode: TGetExErrorCode;
    _QueryEcrIdent: TQueryEcrIdent;
    _QueryEcrDateTime: TQueryEcrDateTime;
    _SynchronazeDateTime: TSynchronazeDateTime;
    //    (  )
    function IsCheckAnn: string;
    function WaitEndOfCheckPrinting: string;
    procedure AddCheckLineInternal(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString; Dep: integer);
    procedure InitFR(const ARMName: String);
    function CheckError(Code: integer): string;
    procedure RaiseIfError(Code: integer);

  public
    DLL: cardinal;
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, arMaxDataForm, comctrls, Forms, Math;

type
  TINI = class(TIniObject)
  private
    FCOM_Port: integer;
    FTimeOut: integer;
    FBaudRate: integer;
    FPassword: string;
  published
    property COM_Port: integer read FCOM_Port write FCOM_Port;
    property BaudRate: integer read FBaudRate write FBaudRate;
    property TimeOut: integer read FTimeOut write FTimeOut;
    property Password: string read FPassword write FPassword;
  end;


const
  SUCCESS = 0; //  
  ERR_CONN_OPENED = 1; //     
  ERR_CONN_CLOSED = 2; //     
  ERR_NO_RESPONSE = 3; //   
  ERR_REC_OPENED = 4; //   
  ERR_REC_NOOPEN = 5; //   
  ERR_DOC_OVERFLOW = 7; //     ;
  ERR_INVALID_ARG = 14; //   .
  ERR_OS_ERROR = 17; //   
  ERR_ECR_ERROR = 18; //  
  ERR_INTERNAL = 20; //   
  ERR_BLANKING_NEEDED = 21; //   
  ERR_TO_LITTLE_CASHES = 22; //      
  ERR_VALUE_NOT_DEFINED = 23; //   
  ERR_PASSWORD_NOT_VALID = 24; //  

  ///////////////////////////////////////////////////////////////////////////////
  //     ( ERR_INVALID_ARG).
  ///////////////////////////////////////////////////////////////////////////////

  EX_IAE_NO_ERROR = 0; //   
  EX_IAE_INVALID_PORT_NUM = 1; //   
  EX_IAE_INVALID_BAUD_RATE = 2; //     
  EX_IAE_UNSUPPORTED_BAUD_RATE = 3; //        
  EX_IAE_INVALID_TIMEOUT = 4; //   
  EX_IAE_INVALID_OPER_NUM = 6; //   
  EX_IAE_INVALID_OPER_TYPE = 8; //   
  EX_IAE_UNSUPPORTED_OPER_TYPE = 9; //      
  EX_IAE_INVALID_PAY_TYPE = 17; //   
  EX_IAE_UNSUPPORTED_PAY_TYPE = 18; //      
  EX_IAE_INVALID_PAY_SUM = 20; //    
  EX_IAE_INVALID_ENTRY_SUM = 21; //    
  EX_IAE_INVALID_DEPARTMENT = 22; //   
  EX_IAE_INVALID_ENTRY_CODE = 23; //    
  EX_IAE_INVALID_ADJUSTMENT = 24; //    / 
  EX_IAE_INVALID_QUANTITY = 25; //   
  EX_IAE_INVALID_QUAN_PREC = 26; //    
  EX_IAE_INVALID_TAX_INDEX = 27; //     
  EX_IAE_TOTAL_OVERFLOW = 28; //    
  EX_IAE_INVALID_HEADER_LINE = 29; //    
  EX_IAE_INVALID_ENTRY_TYPE = 30; //   

  ///////////////////////////////////////////////////////////////////////////////
  //      ( ERR_ECR_ERROR).
  ///////////////////////////////////////////////////////////////////////////////

  EXT_EE_NO_ERROR = 0; //    
  EXT_EE_END_OF_PAPER = 1; //    
  EXT_EE_PRN_ERROR = 2; //  

/////////////////////////////////////////////////////////////////////
  
destructor TKKMNetDBSrvDataGate.Destroy;
begin
  inherited;
end;


procedure TKKMNetDBSrvDataGate.Initialize;
begin
  inherited;
  InitFR('');
end;

procedure TKKMNetDBSrvDataGate.LoadFromDBFToKKMSrv( const InFileName: WideString);
begin
end;

function TKKMNetDBSrvDataGate.SaveFromKKMSrvToDBF: WideString;
begin
end;

function TKKMNetDBSrvDataGate.SaveFromKKMsrvToDBFAvg: WideString;
begin
end;

function TKKMNetDBSrvDataGate.GetCurrentRetailSkald: WideString;
begin
end;

function TKKMNetDBSrvDataGate.TradeGetPrices: WideString;
begin
end;

procedure TKKMNetDBSrvDataGate.TradeLoadTovarFromBar(var InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastDocs(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastDocs_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.GetKSSales(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetKSSales_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateAgents(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovar(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecks(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecks_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateStudents(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarFromBar(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetPrihodToBar(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsSalesFromBar(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetPrihodToBar_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarE(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecs_X(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecs_Z(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecs_Z_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReports_X(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReports_Z(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReports_Z_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.GetZReportsFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReportsShort_X(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReportsShort_Z(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastZReportsShort_Z_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.GetZReportsShortFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetChecsFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetCurrOst(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarE_Fast(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetChecsZRep(const OutFileName, Z_REP: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetChecsZRepSokr(const OutFileName, ZR_Sokr: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateDicountCards(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarOutOfRoad(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecsOfRoad(const OutFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetLastChecsOfRoad_IsOK(IsOK: Shortint);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarAll(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.GetChecsZRepKKM(const OutFileName, ZR_KKM: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarByName(const InFileName: WideString);
begin
end;

procedure TKKMNetDBSrvDataGate.TestDBFSpeed(const OutFileName: WideString);
begin
end;

function TKKMNetDBSrvDataGate.CheckError(Code: integer): string;
  var s: string;
begin
  if Code = SUCCESS then exit;
  case Code of
    ERR_CONN_OPENED: s := '    ';
    ERR_CONN_CLOSED: s := '    ';
    ERR_NO_RESPONSE: s := '  ';
    ERR_REC_OPENED: s := '  ';
    ERR_REC_NOOPEN: s := '  ';
    ERR_DOC_OVERFLOW: s := 'C    ;';
    ERR_INVALID_ARG: s := '  .';
    ERR_OS_ERROR: s := '  ';
    ERR_ECR_ERROR: s := ' ,      ';
    ERR_INTERNAL: s := '  ';
    ERR_BLANKING_NEEDED: s := '  ';
    ERR_TO_LITTLE_CASHES: s := '     ';
    ERR_VALUE_NOT_DEFINED: s := '  ';
    ERR_PASSWORD_NOT_VALID: s := ' ';
    else s := '  ';
  end;
  Result := s;
end;

procedure TKKMNetDBSrvDataGate.CreateCheck(const ARMName: WideString; CheckKind: Integer);
begin
  RaiseIfError(_OpenReceipt(CheckKind));
end;

procedure TKKMNetDBSrvDataGate.AddCheckLineInternal(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString; Dep: integer);
   var s: string;
begin
  s := Name;
  RaiseIfError(_AddRecEntry(Price, round(Kolvo*1000), 3, Price*Kolvo, Dep, 0, PLU, PChar(s)));
end;

procedure TKKMNetDBSrvDataGate.AddCheckLine(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString);
begin
  AddCheckLineInternal(PLU,Name,Price,Kolvo,EdIzm,1);
end;

function TKKMNetDBSrvDataGate.CloseCheck: WideString;
begin
  Result := CheckError(_CloseReceipt(1));
end;

function TKKMNetDBSrvDataGate.XReport(const ARMName: WideString): WideString;
begin
  Result := CheckError(_Xreport);
end;

function TKKMNetDBSrvDataGate.ZReport(const ARMName: WideString): WideString;
begin
  Result := CheckError(_Zreport);
end;

function TKKMNetDBSrvDataGate.CashInOut(const ARMName: WideString; Value: Currency): WideString;
  var k: integer;
begin
  if Value < 0 then k := 3 else k := 2;
  RaiseIfError(_OpenReceipt(k));
  RaiseIfError(_AddRecEntry(0,0,0,abs(Value),0,0,0,''));
  Result := CheckError(_CloseReceipt(1));
end;

function TKKMNetDBSrvDataGate.ContinueAfterError(const ARMName: WideString): WideString;
begin
  try
  InitFR('');
  Result := '';
  except
    on e: exception do Result := e.Message;
  end;
end;

procedure TKKMNetDBSrvDataGate.InitFR(const ARMName: String);
  var INI: TINI;
      r: integer;
begin
  if DLL <> 0 then begin
    if Assigned(_Disconnect) then _Disconnect;
    FreeLibrary(DLL);
    DLL := 0;
  end;
  DLL := LoadLibrary('drvmercfr.dll');
  if DLL = 0 then raise Exception.Create(' drvmercfr.dll  ');
  _Connect := GetProcAddress(DLL, 'Connect');                         if not Assigned(_Connect) then raise Exception.Create(' Connect    DLL');
  _Disconnect := GetProcAddress(DLL, 'Disconnect');                   if not Assigned(_Disconnect) then raise Exception.Create(' Disconnect    DLL');
  _RegisterOper := GetProcAddress(DLL, 'RegisterOper');               if not Assigned(_RegisterOper) then raise Exception.Create(' RegisterOp    DLL');
  _GetCurrOper := GetProcAddress(DLL, 'GetCurrOper');                 if not Assigned(_GetCurrOper) then raise Exception.Create(' GetCurrOper    DLL');
  _GetTaxNum := GetProcAddress(DLL, 'GetTaxNum');                     if not Assigned(_GetTaxNum) then raise Exception.Create(' GetTaxNum    DLL');
  _GetTaxRate := GetProcAddress(DLL, 'GetTaxRate');                   if not Assigned(_GetTaxRate) then raise Exception.Create(' GetTaxRate    DLL');
  _OpenReceipt := GetProcAddress(DLL, 'OpenReceipt');                 if not Assigned(_OpenReceipt) then raise Exception.Create(' OpenReceipt    DLL');
  _AddRecEntry := GetProcAddress(DLL, 'AddRecEntry');                 if not Assigned(_AddRecEntry) then raise Exception.Create(' AddRecEntry    DLL');
  _AddRecAdjust := GetProcAddress(DLL, 'AddRecAdjust');               if not Assigned(_AddRecAdjust) then raise Exception.Create(' AddRecAdjust    DLL');
  _AddPay := GetProcAddress(DLL, 'AddPay');                           if not Assigned(_AddPay) then raise Exception.Create(' AddPay    DLL');
  _CloseReceipt := GetProcAddress(DLL, 'CloseReceipt');               if not Assigned(_CloseReceipt) then raise Exception.Create(' CloseReceipt    DLL');
  _Zreport := GetProcAddress(DLL, 'Zreport');                         if not Assigned(_Zreport) then raise Exception.Create(' Zreport    DLL');
  _Xreport := GetProcAddress(DLL, 'Xreport');                         if not Assigned(_Xreport) then raise Exception.Create(' Xreport    DLL');
  _GetExErrorCode := GetProcAddress(DLL, 'GetExErrorCode');           if not Assigned(_GetExErrorCode) then raise Exception.Create(' GetExErrorCode    DLL');
  _QueryEcrIdent := GetProcAddress(DLL, 'QueryEcrIdent');             if not Assigned(_QueryEcrIdent) then raise Exception.Create(' QueryEcrIdent    DLL');
  _QueryEcrDateTime := GetProcAddress(DLL, 'QueryEcrDateTime');       if not Assigned(_QueryEcrDateTime) then raise Exception.Create(' QueryEcrDateTime    DLL');
  _SynchronazeDateTime := GetProcAddress(DLL, 'SynchronazeDateTime'); if not Assigned(_SynchronazeDateTime) then raise Exception.Create(' SynchronazeDateTime    DLL');
  INI := TINI.Create;
  try
    INI.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
    r := _Connect(INI.COM_Port, INI.BaudRate, INI.TimeOut, PChar(INI.Password));
    if r <> 0 then r := _Connect(INI.COM_Port, INI.BaudRate, INI.TimeOut, PChar(INI.Password));
  finally
    INI.Free;
  end;
  RaiseIfError(r);
  r := _RegisterOper(1, 'OLE');
  if r <> 0 then r := _RegisterOper(1, 'OLE');
  RaiseIfError(r);
end;

function TKKMNetDBSrvDataGate.RepeatLastCheck(const ARMName: WideString): WideString;
begin
  result := '  ';
end;

function TKKMNetDBSrvDataGate.WaitEndOfCheckPrinting: string;
begin
end;


procedure TKKMNetDBSrvDataGate.AddCheckLineDep(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; Dep: Integer);
begin
  AddCheckLineInternal(PLU,Name,Price,Kolvo,'',Dep);
end;

procedure TKKMNetDBSrvDataGate.AddPackParty(const InFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.ChangeBarcodes(const InFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.ConnectByAlias(const AliasName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.ConnectByPath(const Path: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.DeleteGroup(IDGROUP: Integer);
begin

end;

procedure TKKMNetDBSrvDataGate.DeleteTovar(IDTOV: Integer);
begin

end;

procedure TKKMNetDBSrvDataGate.DisconnectFromDB;
begin

end;

procedure TKKMNetDBSrvDataGate.ExecuteW(const SQL: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.ExecuteWS(const SQL: WideString);
begin

end;

function TKKMNetDBSrvDataGate.Get_DataBasePath: WideString;
begin

end;

function TKKMNetDBSrvDataGate.Get_MemFieldCount: Integer;
begin

end;

function TKKMNetDBSrvDataGate.Get_MemRowCount: Integer;
begin

end;

function TKKMNetDBSrvDataGate.Get_X10UnitsCount: Integer;
begin

end;

procedure TKKMNetDBSrvDataGate.GetAgentsInfo(
  const OutFileName: WideString);
begin

end;

function TKKMNetDBSrvDataGate.GetIDStoreLength: SYSINT;
begin

end;

function TKKMNetDBSrvDataGate.GetIDTovarLength: SYSINT;
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastChecsByKKMSN_X(const OutFileName,
  KKMSN: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastChecsByKKMSN_Z(const OutFileName,
  KKMSN: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastChecsByKKMSN_Z_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsBySN(const OutFileName,
  KKMSN: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsBySN_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsEx(
  const OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsEx_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsWSpec(const HeadFileName,
  SpecFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsWSpec_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsWSpecWOZero(const HeadFileName,
  SpecFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastDocsWSpecWOZero_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastGrChecks_X(
  const OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastGrChecks_Z(
  const OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetLastGrChecks_Z_IsOK(IsOK: Shortint);
begin

end;

procedure TKKMNetDBSrvDataGate.GetPackParty(const OutFileName,
  PartyNo: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetRestsForDate(const OutFileName,
  DRest: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.GetTovarsInfo(
  const OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarE_BC(
  const InFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.InsertOrUpdateTovarInv(
  const InFileName: WideString);
begin

end;

function TKKMNetDBSrvDataGate.IsCheckAnn: string;
begin

end;

function TKKMNetDBSrvDataGate.MemData(Row, Field: Integer): WideString;
begin

end;

function TKKMNetDBSrvDataGate.MemDataN(Row, Field: Integer): WideString;
begin

end;

function TKKMNetDBSrvDataGate.MemFieldName(Field: Integer): WideString;
begin

end;

function TKKMNetDBSrvDataGate.MemID2Row(ID: Integer): Integer;
begin

end;

procedure TKKMNetDBSrvDataGate.SelectR(const SQL, OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.SelectW(const SQL, OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.SelectWS(const SQL,
  OutFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.Set_DataBasePath(const Value: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.StartGetTovarInfo;
begin

end;

procedure TKKMNetDBSrvDataGate.UpdateTovarUseBefore(
  const InFileName: WideString);
begin

end;

procedure TKKMNetDBSrvDataGate.UpdTovCountryGTDByExtrn(
  const InFileName: WideString);
begin

end;

function TKKMNetDBSrvDataGate.X10UnitName(Index: Integer): WideString;
begin

end;

function TKKMNetDBSrvDataGate.X10UnitOnOffState(Index: Integer): Integer;
begin

end;

procedure TKKMNetDBSrvDataGate.X10UnitSetState(const Name: WideString;
  PowerOn, PowerValue: Integer);
begin

end;

function TKKMNetDBSrvDataGate.X10UnitValue(Index: Integer): Integer;
begin

end;

procedure TKKMNetDBSrvDataGate.RaiseIfError(Code: integer);
  var s: string;
begin
  s := CheckError(Code);
  if s <> '' then Raise Exception.Create(s);
end;

initialization
  TAutoObjectFactory.Create(ComServer, TKKMNetDBSrvDataGate, Class_KKMNetDBSrvDataGate,
    ciMultiInstance, tmApartment);

end.

