unit arMaxX;

interface

uses
  Windows, ComObj, ActiveX, fr_ole_TLB, StdVcl, SysUtils,
  Controls;

type

  TInternalProcedure = procedure(const DBFName: string) of object;
  TInternalProcedureInt = procedure(const IntParam: integer) of object;

  TLastConnectType = (lctStd, lctByAlias, lctByPath);
  TTransactionKind = (tkRead, tkWrite, tkWriteS);

  Tfr_ole_xx = class(TAutoObject, fr_ole_x)
  protected
    // /
    procedure ConnectByAlias(const AliasName: WideString); safecall;
    procedure ConnectByPath(const Path: WideString); safecall;
    procedure DisconnectFromDB; safecall;

    //   
    procedure ExecuteW(const SQL: WideString); safecall;
    procedure ExecuteWS(const SQL: WideString); safecall;
    procedure SelectR(const SQL, OutFileName: WideString); safecall;
    procedure SelectW(const SQL, OutFileName: WideString); safecall;
    procedure SelectWS(const SQL, OutFileName: WideString); safecall;

    //  
    procedure InsertOrUpdateTovar(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarAll(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarByName(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE_BC(const InFileName: WideString); safecall; //   
    procedure InsertOrUpdateTovarInv(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarOutOfRoad(const InFileName: WideString); safecall;

    //    
    function GetIDStoreLength: SYSINT; safecall;
    function GetIDTovarLength: SYSINT; safecall;
    procedure GetTovarsInfo(const OutFileName: WideString); safecall;
    procedure ChangeBarcodes(const InFileName: WideString); safecall;
    procedure DeleteGroup(IDGROUP: Integer); safecall;
    procedure DeleteTovar(IDTOV: Integer); safecall;
    procedure UpdateTovarUseBefore(const InFileName: WideString); safecall;
    procedure UpdTovCountryGTDByExtrn(const InFileName: WideString); safecall;
    procedure GetRestsForDate(const OutFileName, DRest: WideString); safecall;

    //    ( arMaxLabel)
    procedure AddPackParty(const InFileName: WideString); safecall;
    procedure GetPackParty(const OutFileName, PartyNo: WideString); safecall;

    //    (  )
    function CashInOut(const ARMName: WideString; Value: Currency): WideString; safecall;
    function CloseCheck: WideString; safecall;
    function ContinueAfterError(const ARMName: WideString): WideString; safecall;
    function RepeatLastCheck(const ARMName: WideString): WideString; safecall;
    function XReport(const ARMName: WideString): WideString; safecall;
    function ZReport(const ARMName: WideString): WideString; safecall;
    procedure AddCheckLine(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString); safecall;
    procedure AddCheckLineDep(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; Dep: Integer); safecall;
    procedure CreateCheck(const ARMName: WideString; CheckKind: Integer); safecall;

    //    
    procedure GetKSSales(const OutFileName: WideString); safecall;
    procedure GetKSSales_IsOK(IsOK: Shortint); safecall;

    //  
    procedure GetLastDocs(const OutFileName: WideString); safecall;
    procedure GetLastDocs_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsBySN(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastDocsBySN_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsWSpec(const HeadFileName, SpecFileName: WideString); safecall;
    procedure GetLastDocsWSpec_IsOK(IsOK: Shortint); safecall;
    procedure GetLastDocsWSpecWOZero(const HeadFileName, SpecFileName: WideString); safecall;
    procedure GetLastDocsWSpecWOZero_IsOK(IsOK: Shortint); safecall;

    //  
    procedure GetChecsFromTo(const OutFileName, DFrom, DTo: WideString); safecall;
    procedure GetChecsZRep(const OutFileName, Z_REP: WideString); safecall;
    procedure GetChecsZRepKKM(const OutFileName, ZR_KKM: WideString); safecall;
    procedure GetChecsZRepSokr(const OutFileName, ZR_Sokr: WideString); safecall;
    procedure GetLastChecs_X(const OutFileName: WideString); safecall;
    procedure GetLastChecs_Z(const OutFileName: WideString); safecall;
    procedure GetLastChecs_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecsByKKMSN_X(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastChecsByKKMSN_Z(const OutFileName, KKMSN: WideString); safecall;
    procedure GetLastChecsByKKMSN_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetLastGrChecks_X(const OutFileName: WideString); safecall;
    procedure GetLastGrChecks_Z(const OutFileName: WideString); safecall;
    procedure GetLastGrChecks_Z_IsOK(IsOK: Shortint); safecall;

    //   Z-
    procedure GetLastZReports_X(const OutFileName: WideString); safecall;
    procedure GetLastZReports_Z(const OutFileName: WideString); safecall;
    procedure GetLastZReports_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetZReportsFromTo(const OutFileName, DFrom, DTo: WideString); safecall;

    //   Z-
    procedure GetLastZReportsShort_X(const OutFileName: WideString); safecall;
    procedure GetLastZReportsShort_Z(const OutFileName: WideString); safecall;
    procedure GetLastZReportsShort_Z_IsOK(IsOK: Shortint); safecall;
    procedure GetZReportsShortFromTo(const OutFileName, DFrom, DTo: WideString); safecall;

    //  
    procedure GetCurrOst(const OutFileName: WideString); safecall;
    procedure InsertOrUpdateDicountCards(const InFileName: WideString); safecall;
    procedure GetAgentsInfo(const OutFileName: WideString); safecall;

    // /   .   .
    function GetCurrentRetailSkald: WideString; safecall;
    function SaveFromKKMSrvToDBF: WideString; safecall;
    function SaveFromKKMsrvToDBFAvg: WideString; safecall;
    function TradeGetPrices: WideString; safecall;
    procedure GetLastDocsEx(const OutFileName: WideString); safecall;
    procedure GetLastDocsEx_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecks(const OutFileName: WideString); safecall;
    procedure GetLastChecks_IsOK(IsOK: Shortint); safecall;
    procedure GetLastChecsOfRoad(const OutFileName: WideString); safecall;
    procedure GetLastChecsOfRoad_IsOK(IsOK: Shortint); safecall;
    procedure GetPrihodToBar_IsOK(IsOK: Shortint); safecall;
    procedure GetPrihodToBar(const OutFileName: WideString); safecall;
    procedure InsertOrUpdateAgents(const InFileName: WideString); safecall;
    procedure InsertOrUpdateStudents(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarE_Fast(const InFileName: WideString); safecall;
    procedure InsertOrUpdateTovarFromBar(const InFileName: WideString); safecall;
    procedure InsSalesFromBar(const InFileName: WideString); safecall;
    procedure LoadFromDBFToKKMSrv(const InFileName: WideString); safecall;
    procedure TestDBFSpeed(const OutFileName: WideString); safecall;
    procedure TradeLoadTovarFromBar(var InFileName: WideString); safecall;
    procedure X10UnitSetState(const Name: WideString; PowerOn,
      PowerValue: Integer); safecall;
    function Get_X10UnitsCount: Integer; safecall;
    function X10UnitName(Index: Integer): WideString; safecall;
    function X10UnitOnOffState(Index: Integer): Integer; safecall;
    function X10UnitValue(Index: Integer): Integer; safecall;
    procedure StartGetTovarInfo; safecall;
    function Get_MemRowCount: Integer; safecall;
    function MemData(Row, Field: Integer): WideString; safecall;
    function MemDataN(Row, Field: Integer): WideString; safecall;
    function Get_MemFieldCount: Integer; safecall;
    function MemFieldName(Field: Integer): WideString; safecall;
    function MemID2Row(ID: Integer): Integer; safecall;
    function Get_DataBasePath: WideString; safecall;
    procedure Set_DataBasePath(const Value: WideString); safecall;
    { Protected declarations }
  private
    // /
    procedure Connect(DBPathKey: string);
    procedure Disconnect(Commit: boolean);
    procedure InternalConnect(FullRegPathOrFullPath: String; const ByReg: Boolean);
    procedure InternalConnectByAlias(const AliasName: String);
    procedure InternalConnectByPath(const Path: String);

    // 
    function GetGeneratorWrapper(GenName: string): Integer;
    procedure ExecuteSQL(Name, SQL: string; UseSnapRW: boolean = false);
    procedure StdExecuteSQLWrapper(Name, SQL: string; UseSnapRW: Boolean);
    procedure ExportTable(Name, DBFName, SQL: string; const Trans: TTransactionKind);
    procedure ExportTableToMem(Name, SQL: string; const Trans: TTransactionKind);
    procedure StdExportTableWithIsOKWrapper(Name, DBFName, SQL: string; UseSnapRW: boolean);
    procedure StdExportTableWrapper(Name, DBFName, SQL: string; UseSnapRW: boolean);
    procedure StdExportTableWrapperEx(Name, DBFName, SQL: string; const Trans: TTransactionKind);
    procedure StdExportTableMemWrapper(Name, SQL: string; const Trans: TTransactionKind);
    procedure StdInternalProcedureIntWrapper(Proc: TInternalProcedureInt; const IntParam: integer);
    procedure StdInternalProcedureWrapper(Proc: TInternalProcedure; DBFName: string);
    procedure StdIsOKWrapper(IsOK: Shortint);

    //    (  )
    function IsCheckAnn: string;
    function WaitEndOfCheckPrinting: string;
    procedure AddCheckLineInternal(PLU: Integer; const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString; Dep: integer);
    procedure InitFR(const ARMName: String);

    //    
    procedure GetAgWO_INN;

    //  
    procedure InternalInsertOrUpdateTovar(const DBFName: string);
    procedure InternalInsertOrUpdateTovarAll(const DBFName: string);
    procedure InternalInsertOrUpdateTovarByName(const DBFName: string);
    procedure InternalInsertOrUpdateTovarE_Fast(const DBFName: string);
    procedure InternalInsertOrUpdateTovarE_Fast_BC(const DBFName: string);      //   
    procedure InternalInsertOrUpdateTovarE_Fast_BC_Proc(const DBFName: string); //C   
    procedure InternalInsertOrUpdateTovarInv(const DBFName: string);
    procedure InternalInsertOrUpdateTovarOutOfRoad(const DBFName: string);
    procedure TestForExistsGroup3; //  " "

    //    
    procedure InternalChangeBarcodes(const DBFName: string);
    procedure InternalDeleteGroup(const IDGROUP: Integer);
    procedure InternalDeleteTovar(const IDTOV: Integer);
    procedure InternalUpdateTovarUseBefore(const DBFName: string);
    procedure InternalUpdTovCountryGTDByExtrn(const DBFName: string);

    //    
    procedure CreateDocByChecks;
    procedure GetKSSalesInternal(const OutFileName: WideString);

    //    ( arMaxLabel)
    procedure InternalAddPackParty(const DBFName: string);

    //  
    procedure InternalGetCurrOst(const DBFName: string);
    procedure InternalInsertOrUpdateDicountCards(const DBFName: string);

    // /   .   .
    function GetGroupIDByName(GrName: string): Integer;
    function GetTempFileName: string;
    procedure ImportTable(Name, DBFName: string; SQL: string);
    procedure InternalInsertOrUpdateAgents(const DBFName: string);
    procedure InternalInsertOrUpdateStudents(const DBFName: string);
    procedure InternalInsertOrUpdateTovarE(const DBFName: string);
    procedure InternalInsertOrUpdateTovarFromBar(const DBFName: string);
    procedure InternalInsSalesFromBar(const DBFName: string);
    procedure Pack(FromPath, ToPath: string);
    procedure Repaint;
    procedure RunProcess(Cmd: string);
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, comctrls, Forms, Math;

const
  ArmaxNetRegKey = 'ArmaxNet';

destructor Tfr_ole_xx.Destroy;
begin
  inherited;
end;

procedure Tfr_ole_xx.InternalConnectByAlias(const AliasName: String);
begin
end;

procedure Tfr_ole_xx.InternalConnectByPath(const Path: String);
begin
end;

procedure Tfr_ole_xx.InternalConnect(FullRegPathOrFullPath: String; const ByReg: Boolean);
begin
end;


procedure Tfr_ole_xx.Connect(DBPathKey: string);
begin
end;

procedure Tfr_ole_xx.Disconnect(Commit: boolean);
begin
end;

procedure Tfr_ole_xx.Initialize;
begin
  inherited;
end;

procedure Tfr_ole_xx.LoadFromDBFToKKMSrv(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.ImportTable(Name, DBFName, SQL: string);
begin
end;

procedure Tfr_ole_xx.Repaint;
begin
end;

procedure Tfr_ole_xx.Pack(FromPath, ToPath: string);
begin
end;

procedure Tfr_ole_xx.RunProcess(Cmd: string);
begin
end;

procedure Tfr_ole_xx.ExportTable(Name, DBFName, SQL: string; const Trans: TTransactionKind);
begin
end;

function Tfr_ole_xx.SaveFromKKMSrvToDBF: WideString;
begin
end;

function Tfr_ole_xx.SaveFromKKMsrvToDBFAvg: WideString;
begin
end;

function Tfr_ole_xx.GetTempFileName: string;
begin
end;

function Tfr_ole_xx.GetCurrentRetailSkald: WideString;
begin
end;

function Tfr_ole_xx.TradeGetPrices: WideString;
begin
end;

procedure Tfr_ole_xx.TradeLoadTovarFromBar(var InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocs(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocs_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.ExecuteSQL(Name, SQL: string;  UseSnapRW: boolean);
begin
end;

procedure Tfr_ole_xx.GetKSSales(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetKSSales_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetKSSalesInternal(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateAgents(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovar(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovar(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.CreateDocByChecks;
begin
end;

procedure Tfr_ole_xx.GetAgWO_INN;
begin
end;

procedure Tfr_ole_xx.TestForExistsGroup3;
begin
end;

procedure Tfr_ole_xx.GetLastChecks(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecks_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateStudents(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateStudents(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarFromBar(const InFileName: WideString);
begin
end;

function Tfr_ole_xx.GetGroupIDByName(GrName: string): Integer;
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarFromBar(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetPrihodToBar(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InsSalesFromBar(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetPrihodToBar_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.InternalInsSalesFromBar(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarE(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarE(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetLastChecs_X(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecs_Z(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecs_Z_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetLastZReports_X(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastZReports_Z(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastZReports_Z_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetZReportsFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure Tfr_ole_xx.StdExportTableWrapper(Name, DBFName, SQL: string; UseSnapRW: boolean);
begin
end;

procedure Tfr_ole_xx.StdExecuteSQLWrapper(Name, SQL: string; UseSnapRW: Boolean);
begin
end;


procedure Tfr_ole_xx.StdExportTableWrapperEx(Name, DBFName, SQL: string; const Trans: TTransactionKind);
begin
end;


procedure Tfr_ole_xx.StdIsOKWrapper(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.StdInternalProcedureWrapper(Proc: TInternalProcedure; DBFName: string);
begin
end;

procedure Tfr_ole_xx.StdExportTableWithIsOKWrapper(Name, DBFName, SQL: string; UseSnapRW: boolean);
begin
end;

procedure Tfr_ole_xx.GetLastZReportsShort_X(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastZReportsShort_Z(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastZReportsShort_Z_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetZReportsShortFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure Tfr_ole_xx.GetChecsFromTo(const OutFileName, DFrom, DTo: WideString);
begin
end;

procedure Tfr_ole_xx.GetCurrOst(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarE_Fast(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarE_Fast(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetChecsZRep(const OutFileName, Z_REP: WideString);
begin
end;

procedure Tfr_ole_xx.InternalGetCurrOst(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetChecsZRepSokr(const OutFileName, ZR_Sokr: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateDicountCards(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateDicountCards(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarOutOfRoad(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarOutOfRoad(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetLastChecsOfRoad(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecsOfRoad_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarAll(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarAll(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetChecsZRepKKM(const OutFileName, ZR_KKM: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarByName(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarByName(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.TestDBFSpeed(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.AddCheckLineInternal(PLU: Integer;
  const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString; Dep: integer);
{  var OPCODE: integer;
      N, e: string;
      D: char;
      Q: TiQuery;}
begin
{  D := DecimalSeparator;
  if CHECK_KIND_ID = 0 then OPCODE := 8 else OPCODE := 32+8;
  N := Name;
  E := EdIzm;
  if OPERATION_COUNT = 0 then raise Exception.Create('  ');
  try
    DecimalSeparator := '.';
    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateMQuery(Format(
        'insert into CHK_SALES '+
        ' (ID, CHECK_ID, NOMPOS, OPCODE, DepartmentID, I_CODE, BARCODE, SHORTNAME, '+
        '  PRICE, KOLVO, SUMM, RealSumm, weight, UNIT, Taxes) '+
        'values '+
        ' (gen_id(GEN_CHK_SALES, 1), %d, %d, %d, %d, %d, '''', ''%s'', '+
        '  %f, %f, %f, %f, 0, ''%s'', 0); ',
        [CHECK_ID, OPERATION_COUNT, OPCODE, Dep, PLU, N, Price, Kolvo, Price*Kolvo, Price*Kolvo, E]));
      try
        Q.ExecQuery;
        Q.Close;
      finally
        Q.Free;
      end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;

    OPERATION_COUNT := OPERATION_COUNT + 1;
    CHECK_SUMM := CHECK_SUMM + Price * Kolvo;
  finally
    DecimalSeparator := D;
  end;}
end;

procedure Tfr_ole_xx.AddCheckLine(PLU: Integer;
  const Name: WideString; Price, Kolvo: Currency; const EdIzm: WideString);
begin
  AddCheckLineInternal(PLU,Name,Price,Kolvo,EdIzm,1);
end;

function Tfr_ole_xx.CloseCheck: WideString;
{var D: char;
    Q: TiQuery;}
begin
{  D := DecimalSeparator;
  try
    DecimalSeparator := '.';
    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateMQuery(Format(
        'update CHECKS C set C.OPERATION_COUNT = %d, C.TOTAL = %f, C.FULL_TOTAL = %f, C.KKM_TOTAL = %f, C.CACHE_IN = %f  where C.ID = %d',
        [OPERATION_COUNT-1, CHECK_SUMM, CHECK_SUMM, CHECK_SUMM, CHECK_SUMM, CHECK_ID]));
      try
        Q.ExecQuery;
        Q.Close;
      finally
        Q.Free;
      end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;
  finally
    DecimalSeparator := D;
  end;

  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q := DefConnection.CreateMQuery(Format(
      'execute procedure RECALC_CHECK (%d)', [CHECK_ID]));
    try
      Q.ExecQuery;
      Q.Close;
    finally
      Q.Free;
    end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;

  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q := DefConnection.CreateMQuery(Format(
      'insert into CHECKS_FRS(CHECK_ID, ID_WS) values(%d, %d)', [CHECK_ID, ID_FR]));
    try
      Q.ExecQuery;
      Q.Close;
    finally
      Q.Free;
    end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
  Result := WaitEndOfCheckPrinting;

  if Result = '' then Result := IsCheckAnn;
  if Result = '' then begin
    OPERATION_COUNT := 0;
    CHECK_ID := 0;
  end;

  try
  Disconnect(true);
  except
  end;}
end;

function Tfr_ole_xx.XReport(const ARMName: WideString): WideString;
//var Q1: TiQuery;
begin
{  InitFR(ARMName);
  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q1 := DefConnection.CreateMQuery(Format('update FRs set CMDTODO = 4, LASTERROR = '''' where ID = %d',[ID_FR]));
    try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
  Result := WaitEndOfCheckPrinting;
  try
  Disconnect(true);
  except
  end;}
end;

function Tfr_ole_xx.ZReport(const ARMName: WideString): WideString;
//var Q1: TiQuery;
begin
{  InitFR(ARMName);
  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q1 := DefConnection.CreateMQuery(Format('update FRs set CMDTODO = 2, LASTERROR = '''' where ID = %d',[ID_FR]));
    try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
  Result := WaitEndOfCheckPrinting}
end;

function Tfr_ole_xx.CashInOut(const ARMName: WideString;
  Value: Currency): WideString;
{var DS: char;
      V: currency;
      Q: TiQuery;}
begin
{  InitFR(ARMName);
  V := abs(Value);
  DS := DecimalSeparator;
  DecimalSeparator := '.';
  try
    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateQuery('select gen_id(GEN_CHECKS, 1) from RDB$DATABASE');
      try
        Q.ExecQuery;
        CHECK_ID := Q.Fields[0].AsInteger;
        Q.Close;
      finally
        Q.Free;
      end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;

    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateMQuery(Format(
      'insert into Checks (ID, ID_WS, DATASTART, OPERATOR, CHECK_KIND_ID, TOTAL, KKM_TOTAL, FULL_TOTAL, OPERATION_COUNT, KKM_SN)'+
      'values (%d, %d, current_timestamp, ''%s'', 3, %f, %f, %f, 1)', [CHECK_ID, ID_FR, V, V, V, FR_SN]));
      try Q.ExecQuery; Q.Close; finally Q.Free; end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;

    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateMQuery(Format(
       'insert into CHK_PAYS(ID, CHECK_ID, NomPos, OpCode, Summa) values (gen_id(GEN_CHK_PAYS, 1), %d, 1, %d, %f)',
       [CHECK_ID, 96 + integer(Value>0)*16, V]));
      try Q.ExecQuery; Q.Close; finally Q.Free; end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;

//   DefConnection.ExecuteQuery(Format('execute procedure RECALC_CHECK (%d)', [CHECK_ID]));

    DefConnection.DefaultModifyTransaction.StartTransaction;
    try
      Q := DefConnection.CreateMQuery(Format(
        'insert into CHECKS_FRS(CHECK_ID, ID_WS) values(%d, %d);', [CHECK_ID, ID_FR]));
      try Q.ExecQuery; Q.Close; finally Q.Free; end;
      DefConnection.DefaultModifyTransaction.Commit;
    except
      DefConnection.DefaultModifyTransaction.Rollback;
      raise;
    end;
  finally
    DecimalSeparator := DS;
  end;
  Result := WaitEndOfCheckPrinting;
  try
  Disconnect(true);
  except
  end;  }
end;

function Tfr_ole_xx.ContinueAfterError(
  const ARMName: WideString): WideString;
//var Q1: TiQuery;
begin
{  InitFR(ARMName);
  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q1 := DefConnection.CreateMQuery(Format('update FRs set CMDTODO = 0, LASTERROR = '''' where ID = %d',[ID_FR]));
    try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
  Result := WaitEndOfCheckPrinting;
  if Result = '' then Result := IsCheckAnn;
  if Result = '' then begin
    OPERATION_COUNT := 0;
    CHECK_ID := 0;
  end;
  try
  Disconnect(true);
  except
  end;}
end;

procedure Tfr_ole_xx.InitFR(const ARMName: String);
{  var s, n: string;
      l: cardinal;
      i: integer;
      Q, Q1: TiQuery;
      fmAddFR: TfmAddFR;}
begin
{  Application.MainForm.Hide;
  if not DefConnection.Connected then Connect(ArmaxNetRegKey);
  //   
  l := 1000;
  SetLength(n, l);
  GetComputerName(@(n[1]), l);
  SetLength(n, l);
  n := AnsiUpperCase(n);
  //  "  "
  s := ARMName;
  s := s + n;
  l := 0;
  for i := 1 to Length(s) do
    if (i and 1) = 0 then l := l + integer(s[i])*33 else l := l + integer(s[i])*37;

  Q := DefConnection.CreateQuery;
  try
    //  . ,   
    Q.Text := Format('select ID from Servers where Upper(Name collate PXW_CYRL) = ''%s''', [n]);
    repeat
      Q.ExecQuery;
      if not Q.Eof then begin
        ID_Server := Q.Fields[0].AsInteger;
        Q.Close;
        break;
      end else begin
        DefConnection.DefaultModifyTransaction.StartTransaction;
        try
          Q1 := DefConnection.CreateMQuery(Format('insert into Servers (ID, NAME) values (gen_id(GEN_Servers, 1), ''%s'')', [n]));
          try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
          DefConnection.DefaultModifyTransaction.Commit;
        except
          DefConnection.DefaultModifyTransaction.Rollback;
          raise;
        end;
        Q.Close;
        continue;
      end;
    until false;

    Q.Text := 'select ID, ID_Server, ID_WS from ARMs where ID_ARM_Model = 4 and SerialNumber = ' + IntToStr(l);
    repeat
      Q.ExecQuery;
      if not Q.Eof then begin
        ID_ARM := Q.Fields[0].AsInteger;
        if Q.Fields[1].AsInteger <> ID_Server then begin
          DefConnection.DefaultModifyTransaction.StartTransaction;
          try
            Q1 := DefConnection.CreateMQuery(Format('update ARMs set ID_Server = %d where ID = %d', [ID_Server, ID_ARM]));
            try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
            DefConnection.DefaultModifyTransaction.Commit;
          except
            DefConnection.DefaultModifyTransaction.Rollback;
            raise;
          end;
          Q.Close;
          continue;
        end;
        Q.Close;
        break;
      end else begin
        DefConnection.DefaultModifyTransaction.StartTransaction;
        try
          Q1 := DefConnection.CreateMQuery(Format('insert into ARMs (ID, ID_Server, ID_ARM_Model, SerialNumber) values (gen_id(GEN_ARMs, 1), %d, 4, %d)', [ID_Server, l]));
          try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
          DefConnection.DefaultModifyTransaction.Commit;
        except
          DefConnection.DefaultModifyTransaction.Rollback;
          raise;
        end;
        Q.Close;
        continue;
      end;
    until false;

    Q.Text := 'select first 1 ARM_FRs.ID_FR, FRS.SERIALNUMBER from ARM_FRs left join FRS on (ARM_FRs.ID_FR = FRs.ID) where ID_ARM = ' + IntToStr(ID_ARM);
    repeat
      Q.ExecQuery;
      if not Q.Eof then begin
        ID_FR := Q.Fields[0].AsInteger;
        FR_SN := Q.Fields[1].AsInteger;
        Q.Close;
        break;
      end else begin
        MessageBox(0, PChar('      .'#13#10 +
                   '       .'#13#10 +
                   '       '+
                   ' -    " - "   " ".')
                   , '', MB_ICONINFORMATION or MB_SETFOREGROUND);
        fmAddFR := TfmAddFR.Create(Application);
        try
          fmAddFR.ID_ARM := ID_ARM;
          fmAddFR.ShowModal;
        finally
          fmAddFR.Free;
        end;
        continue;
      end;
    until false;

  finally
    Q.Free;
  end;      }
end;

function Tfr_ole_xx.RepeatLastCheck(
  const ARMName: WideString): WideString;
//var Q1: TiQuery;
begin
{  InitFR(ARMName);
  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q1 := DefConnection.CreateMQuery(Format('update FRs set CMDTODO = 5, LASTERROR = '''' where ID = %d',[ID_FR]));
    try Q1.ExecQuery; Q1.Close; finally Q1.Free end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
  Result := WaitEndOfCheckPrinting;
  try
  Disconnect(true);
  except
  end;      }
end;

function Tfr_ole_xx.WaitEndOfCheckPrinting: string;
//  var Q: TiQuery;
  //    CmdToDo, CHECK_ID: integer;
begin
{  Q := DefConnection.CreateQuery(Format(
    'select first 1 F.CMDTODO, '+
    '   iif(C.ID is NULL, 0, C.ID) as CHECK_ID, '+
    '   F.LASTERROR '+
    ' from FRs F '+
    '   left join CHECKS C on (F.ID = C.ID_WS and C.PRINT_COUNT in (0,-4) ) '+
    ' where FRs.ID = %d order by C.ID ',
    [ID_FR]));
  try
    repeat
      Q.ExecQuery;
      CmdToDo := Q.FieldByName['CMDTODO'].AsInteger;
      CHECK_ID := Q.FieldByName['CHECK_ID'].AsInteger;
      Result := Q.FieldByName['LASTERROR'].AsString;
      if CmdToDo = -1 then exit;
      if (CmdToDo = 0) and (CHECK_ID = 0) then break;
      sleep(200);
    until false;
  finally
    Q.Free;
  end;      }
end;

function Tfr_ole_xx.IsCheckAnn: string;
//  var Q: TiQuery;
  //    PC: integer;
begin
{  if CHECK_ID = 0 then begin
    Result := '';
    exit;
  end;
  Q := DefConnection.CreateQuery(Format(
    'select PRINT_COUNT from CHECKS where ID = %d', [CHECK_ID]));
  try
    Q.ExecQuery;
    PC := Q.Fields[0].AsInteger;
    if PC = -1 then Result := '0' else Result := '';
    Q.Close;
  finally
    Q.Free;
  end;}
end;

procedure Tfr_ole_xx.UpdTovCountryGTDByExtrn(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalUpdTovCountryGTDByExtrn(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.DeleteGroup(IDGROUP: Integer);
begin
end;

procedure Tfr_ole_xx.DeleteTovar(IDTOV: Integer);
begin
end;

procedure Tfr_ole_xx.InternalDeleteGroup(const IDGROUP: Integer);
begin
end;

procedure Tfr_ole_xx.InternalDeleteTovar(const IDTOV: Integer);
begin
end;

procedure Tfr_ole_xx.StdInternalProcedureIntWrapper(Proc: TInternalProcedureInt; const IntParam: integer);
begin
end;

procedure Tfr_ole_xx.ChangeBarcodes(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalChangeBarcodes(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetLastChecsByKKMSN_X(const OutFileName, KKMSN: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecsByKKMSN_Z(const OutFileName, KKMSN: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastChecsByKKMSN_Z_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetLastGrChecks_X(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastGrChecks_Z(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastGrChecks_Z_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.GetLastDocsEx(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsEx_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateAgents(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.AddPackParty(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalAddPackParty(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.GetPackParty(const OutFileName, PartyNo: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsBySN(const OutFileName, KKMSN: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsBySN_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarInv(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarInv(const DBFName: string);
begin
end;

function Tfr_ole_xx.GetIDTovarLength: SYSINT;
begin
end;

function Tfr_ole_xx.GetGeneratorWrapper(GenName: string): Integer;
begin
end;

function Tfr_ole_xx.GetIDStoreLength: SYSINT;
begin
end;

procedure Tfr_ole_xx.UpdateTovarUseBefore(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalUpdateTovarUseBefore(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.AddCheckLineDep(PLU: Integer;
  const Name: WideString; Price, Kolvo: Currency; Dep: Integer);
begin
  AddCheckLineInternal(PLU,Name,Price,Kolvo,'',Dep);
end;

procedure Tfr_ole_xx.ConnectByAlias(const AliasName: WideString);
begin
end;


procedure Tfr_ole_xx.DisconnectFromDB;
begin
end;

procedure Tfr_ole_xx.ConnectByPath(const Path: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsWSpec(const HeadFileName, SpecFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsWSpec_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.ExecuteW(const SQL: WideString);
begin
end;

procedure Tfr_ole_xx.ExecuteWS(const SQL: WideString);
begin
end;

procedure Tfr_ole_xx.SelectR(const SQL, OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.SelectW(const SQL, OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.SelectWS(const SQL, OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetTovarsInfo(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetAgentsInfo(const OutFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsWSpecWOZero(const HeadFileName, SpecFileName: WideString);
begin
end;

procedure Tfr_ole_xx.GetLastDocsWSpecWOZero_IsOK(IsOK: Shortint);
begin
end;

procedure Tfr_ole_xx.X10UnitSetState(const Name: WideString;
  PowerOn, PowerValue: Integer);
begin
end;

function Tfr_ole_xx.Get_X10UnitsCount: Integer;
begin
end;

function Tfr_ole_xx.X10UnitName(Index: Integer): WideString;
begin
end;

function Tfr_ole_xx.X10UnitOnOffState(Index: Integer): Integer;
begin
end;

function Tfr_ole_xx.X10UnitValue(Index: Integer): Integer;
begin
end;

procedure Tfr_ole_xx.StartGetTovarInfo;
begin
end;

procedure Tfr_ole_xx.ExportTableToMem(Name, SQL: string; const Trans: TTransactionKind);
begin
end;

procedure Tfr_ole_xx.StdExportTableMemWrapper(Name, SQL: string; const Trans: TTransactionKind);
begin
end;

function Tfr_ole_xx.Get_MemRowCount: Integer;
begin
end;

function Tfr_ole_xx.MemData(Row, Field: Integer): WideString;
begin
end;

function Tfr_ole_xx.MemDataN(Row, Field: Integer): WideString;
begin
end;

function Tfr_ole_xx.Get_MemFieldCount: Integer;
begin
end;

function Tfr_ole_xx.MemFieldName(Field: Integer): WideString;
begin
end;

function Tfr_ole_xx.MemID2Row(ID: Integer): Integer;
begin
end;

function Tfr_ole_xx.Get_DataBasePath: WideString;
begin
end;

procedure Tfr_ole_xx.Set_DataBasePath(const Value: WideString);
begin
end;

procedure Tfr_ole_xx.GetRestsForDate(const OutFileName, DRest: WideString);
begin
end;

procedure Tfr_ole_xx.InsertOrUpdateTovarE_BC(const InFileName: WideString);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarE_Fast_BC(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.InternalInsertOrUpdateTovarE_Fast_BC_Proc(const DBFName: string);
begin
end;

procedure Tfr_ole_xx.CreateCheck(const ARMName: WideString; CheckKind: Integer);
//  var Q: TiQuery;
begin
{  if OPERATION_COUNT <> 0 then raise Exception.Create('+  v');
  if CheckKind <> 0 then CheckKind := 2;
  InitFR(ARMName);
  CHECK_KIND_ID := CheckKind;
  OPERATION_COUNT := 1;
  CHECK_SUMM := 0;
  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q := DefConnection.CreateQuery('select gen_id(GEN_CHECKS, 1) from RDB$DATABASE');
    try
      Q.ExecQuery;
      CHECK_ID := Q.Fields[0].AsInteger;
      Q.Close;
    finally
      Q.Free;
    end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;

  DefConnection.DefaultModifyTransaction.StartTransaction;
  try
    Q := DefConnection.CreateMQuery(Format(
    'insert into CHECKS (ID, ID_WS, DataStart, CHECK_KIND_ID, KKM_SN) '+
    'values (%d, %d, current_timestamp, %d, %d)', [CHECK_ID, ID_FR, CheckKind, FR_SN]));
    try
      Q.ExecQuery;
      Q.Close;
    finally
      Q.Free;
    end;
    DefConnection.DefaultModifyTransaction.Commit;
  except
    DefConnection.DefaultModifyTransaction.Rollback;
    raise;
  end;
}
end;

initialization
  TAutoObjectFactory.Create(ComServer, Tfr_ole_xx, Class_fr_ole_xx,
    ciMultiInstance, tmApartment);

end.

 = OLE1.ContinueAfterError("arMax_1C_FR_v1"); // ""-   "0"-
OLE1.CreateCheck("arMax_1C_FR_v1", 0);//0  1  
OLE1.AddCheckLine((.),                ,                    ,   1       ,    "");               
 = OLE1.CloseCheck();// ""-   "0"-
    OLE1.ZReport("arMax_1C_FR_v1");
OLE1.XReport("arMax_1C_FR_v1");
